#include <HT32F125x.h>                    // 


main()
{
int i;
uint16_t val;

	HT_CKCU->APBCCR0 |= (1<<14);		// 14=AFIOEN, enable APB clocks for AFIO
	HT_CKCU->APBCCR1 |= (1<<24);		// 24=ADCEN, enable APB clocks for ADC
/*
 PA0 input circuit disabled by default, otherwise must enable GPIO APB clock in CKCU->APBCCR0 
before writing to HT_GPIOA->INER
	HT_GPIOA->INER &= ~(1<<0);		// PA0 input circuit disabled
*/
	HT_AFIO->GPACFGR = 0x01;		// PA0 -> AF1 (ADC)
	HT_CKCU->APBCFGR= (0x06<<16);		// set ADC clock to APB/64 (72/64 = 1,125Mhz)
	// Sampling time = (ADSTn [7:0] + 1.5) A/D Converter clock cycles.
	HT_ADC->STR[0] = 111;			// 112.5 clock cycles -> 100us
	// List of channels to convert, in sequence
	HT_ADC->LST[0] = 0 + (0<<8) + (0<<16) + (0<<24); // ADC_IN0
	// Channels to convert -1 , conversion mode: 0 -> single, 2 -> continuous
	HT_ADC->CONV = (0<<8) + 0;		// 1 channel, single
	// Start conversion source: b0=ADSW, b1=ADEXTI, b2=ADTM
	HT_ADC->TCR = (1<<0);			// software
//	HT_ADC->TSR = ;				// set EXTI and GPTM sources


	for(i=0;i<5;i++){
		HT_ADC->TSR |= (1<<0);		// set ADSC to start conversion
		while(!(HT_ADC->IRAW&(1<<0)));	// wait for EOC
		val=(uint16_t)HT_ADC->DR[0];	// get conversion result
		val&=0xFFF;
	}
	i=HT_ADC->IRAW&(1<<0);			// read EOC	
	HT_ADC->TSR |= (1<<0);			// set ADSC to start conversion
	while(HT_ADC->IRAW&(1<<0))		// wait EOC 1->0
		i++;
	i=0;
}

